/**
 * The angle-comparator didn't consider the normalization
 */

package jmetal.util.comparators;

import java.util.Comparator;

import jmetal.core.Solution;

public class AngleComparator2 implements Comparator{
	
	/** 
	   * stores a comparator for check the OverallConstraintComparator
	   */
	  private static final Comparator overallConstraintViolationComparator_ =
	                              new OverallConstraintViolationComparator();

	@Override
	public int compare(Object object1, Object object2){
		// TODO Auto-generated method stub
		if (object1==null)
		      return 1;
		    else if (object2 == null)
		      return -1;
		
		Solution solution1 = (Solution)object1;
	    Solution solution2 = (Solution)object2;

	    int dominate1 ; // dominate1 indicates if some objective of solution1 
	                    // dominates the same objective in solution2. dominate2
	    int dominate2 ; // is the complementary of dominate1.

	    dominate1 = 0 ; 
	    dominate2 = 0 ;
	    
	    int flag; //stores the result of the comparison

	    if (solution1.getOverallConstraintViolation()!= 
	        solution2.getOverallConstraintViolation() &&
	       (solution1.getOverallConstraintViolation() < 0) ||         
	       (solution2.getOverallConstraintViolation() < 0)){            
	      return (overallConstraintViolationComparator_.compare(solution1,solution2));
	    }
	                                                
	    // Equal number of violated constraints. Applying a dominance Test then
	    double value1, value2;
	    int objs = solution1.numberOfObjectives();
	    double mid = Math.PI/4;
//	    double theta1 = Math.PI/3; // 
//	    double theta2 = Math.PI/4;
//	    double theta2 = Math.PI/3;
//	    double theta2 = 5*Math.PI/12;
	    double theta2 = 4*Math.PI/12;
//	    double theta2 = Math.PI/2;
	    
	        
	    // do judgment 
	    double[] standard1 = new double[objs];
	    standard1[0] = 1;
	    for(int i=1;i<objs;i++) {
	    	standard1[i] = 0;
	    }
	    
	    double[] A = new double[objs];
	    double[] B = new double[objs];
	    for(int i=0;i<objs;i++) { //
	    	A[i] = solution1.getObjective(i);
	    	B[i] = solution2.getObjective(i);
	    }
	    
	    double alpha1 = calcAngle(A, standard1);
	    double alpha2 = calcAngle(B, standard1);
	    
	    // AB
	    double[] standard2 = new double[objs];
	    double[] AB = new double[objs];
	    // BA
	    double[] BA = new double[objs];  
	    for (int i=0;i<objs;i++) {
	    	AB[i] = solution2.getObjective(i) - solution1.getObjective(i);
	    	standard2[i] = 1;
	    	BA[i] = -AB[i];
	    }
	    
	    /*------------------ classification -------------------------*/
	    // -1 : solution1 better; 1 solution2 better; 0 equal.
	    if ((alpha1>mid && alpha2<mid)||(alpha1<mid && alpha2>mid)) {
	    	return 0; 
		}else if (alpha1>mid && alpha2>mid) {
			if(calcAngle(AB, A)<theta2) { // solution 1 dominates
		    	return -1;
		    }else if (calcAngle(BA, B)<theta2) { // solution 2 dominates
				return 1;
			}else {
				return 0; 
			}
		}else { // if (alpha1<mid && alpha2<mid)
			if(calcAngle(AB, A)<theta2) { // solution 1 dominates
		    	return -1;
		    }else if (calcAngle(BA, B)<theta2) { // solution 2 dominates
				return 1;
			}else {
				return 0; 
			}
		}		
	       
} // compare
	
	/**
	 * Calc the angel between two vectors
	 * @param A
	 * @param standard
	 * @return
	 */
	public double calcAngle(double[] A, double[] standard){
		int size = A.length;
		double lenA = 0.0, lenSta = 0.0;
		double theta = 0.0;
		
		for(int i=0;i<size;i++) {
			lenA += A[i]*A[i];
			lenSta += standard[i]*standard[i];
		}
		lenA = Math.sqrt(lenA);
		lenSta = Math.sqrt(lenSta);
		
		double tmp = 0.0;
		for(int j=0;j<size;j++) {
			tmp += A[j]*standard[j];
		}
		
		theta = Math.acos(tmp/(lenA*lenSta));
		
		return theta;	
	}
	

}
